<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useBranchStore } from '@/stores/branch'
import { useExpenseStore } from '@/stores/expense'
import type { Branch } from '@/types/Branch'
import type { Expense } from '@/types/Expense'
import type { User } from '@/types/User'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const expensesStore = useExpenseStore()
const branchStore = useBranchStore()

const yearExpenses = [
  {
    title: 'ID',
    key: 'ROWID',
    value: 'ROWID'
  },
  {
    title: 'Date',
    key: 'createDate',

    value: (expense: any) => new Date(expense.createDate).getFullYear()
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Branch Name',
    key: 'branchName',
    value: 'branchName'
    // value: (expense: any | Branch) => expense.branchName.address
  },
  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  },

  { title: 'Actions', key: 'actions', sortable: false }
]
const yearExpensesDialog = [
  {
    title: 'ID',
    key: 'ROWID',
    value: 'ROWID'
  },
  {
    title: 'Date',
    key: 'createDate',
    value: (expense: any) => new Date(expense.createDate).toLocaleDateString('en-GB')
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  // {
  //   title: 'Branch Name',
  //   key: 'branchName',
  //   value: 'branchName'
  //   // value: (expense: any | Branch) => expense.branchName.address
  // },
  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  }
]
const page = ref(1)

const itemsPerPage = ref<any>(10)
const tab = ref(null)
const pageCount = computed(() => {
  return Math.ceil(expensesStore.expenses.length / itemsPerPage.value)
})
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const loading = ref(false)
const form = ref(false)
const dialogView = ref(false)
const dialogYearly = ref(false)
const dialogDelete = ref(false)
let selectedExpense: Expense | null = null
const search = ref<string>('')
const dialogSumYear = ref(false)
const dialogGraph = ref(false)
const userStore = useAuthStore()
const selectedBranchIndex = ref(null)
const dialogSelectBranch = ref(false)

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
}

async function deleteItemConfirm() {
  // Delete item from list
  await expensesStore.deleteExpense()
  closeDelete()
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
  dialogYearly.value = false
  dialogView.value = false
}

function showSumYear() {
  dialogSumYear.value = true
}

function showGraphYear(selectedYear: any) {
  expensesStore.editedExpense.createDate = selectedYear
  dialogGraph.value = true
}

async function deleteItem(item: Expense) {
  if (!item.id) return
  await expensesStore.getExpense(item.id)
  dialogDelete.value = true
}

// async function save() {
//   const { valid } = await refForm.value!.validate()
//   if (!valid) return
//   closeDialog()
//   await expensesStore.saveExpense()
// }

// const showTableBranch = (branch: any) => {
//   if (branch) {
//     selectedBranchIndex.value = branch.id
//   }
//   dialogSelectBranch.value = false
//   dialogDelete.value = false
//   console.log('Selected branch:', branch)
// }

function showExpense(item: Expense) {
  selectedExpense = item
  dialogView.value = true
}

function showYearExp() {
  // const selectedYear = new Date(expensesStore.editedExpense.createDate).toLocaleDateString(
  //   'en-GB',
  //   { year: 'numeric' }
  // )
  // const filteredExpenses = filterExpensesForYear(expensesStore.expenseYear, selectedYear)
  // const totalYearlyExpenses = calculateYearlyTotal(filteredExpenses)
  // console.log('Total expenses for the selected Year:', totalYearlyExpenses)
  // expensesStore.yearExpense(expensesStore.editedExpense)
  // closeDialog()
  const selectedYear = new Date(expensesStore.editedExpense.createDate).getFullYear()
  const filteredExpenses = filterExpensesForYear(expensesStore.expenseYear, selectedYear.toString())
  const totalYearlyExpenses = calculateYearlyTotal(filteredExpenses)
  console.log('Total expenses for the selected Year:', totalYearlyExpenses)
  expensesStore.yearExpense(expensesStore.editedExpense)
  closeDialog()
}

function calculateYearlyTotal(expenses: any[]) {
  return expenses.reduce((total, expense) => total + expense.totalAmount, 0)
}

onMounted(async () => {
  await expensesStore.getExpenses()
  await branchStore.getBranchs()
  expensesStore.editedExpense.createDate = new Date()
  // expensesStore.yearExpense(expensesStore.editedExpense)
})

function filterExpensesForYear(expenses: any[], selectedYear: string) {
  return expenses.filter((expense) => {
    const expenseYear = new Date(expense.createDate).toLocaleDateString('en-GB', {
      year: 'numeric'
    })
    return expenseYear === selectedYear
  })
}

// const filteredExpenses = computed(() => {
//   const currentUser = userStore.getCurrentUser()
//   if (currentUser && currentUser.branchId) {
//     return expensesStore.expenses.filter(expense => expense.branchId === currentUser.branchId)
//   } else {
//     // If user or branch information is not available, return an empty array
//     return []
//   }
// })

// const filteredExpenses = computed(() => {
//   const selectedBranchId = selectedBranchIndex.value
//   return expensesStore.expenses.filter((expense) => expense.branchName?.id === selectedBranchId)
// })

const isAdmin = computed(() => {
  const currentUser: User | null = userStore.getCurrentUser()
  if (currentUser !== null && currentUser !== undefined) {
    return currentUser.roles.some((role) => role.name === 'Manager' || role.name === 'Owner')
  }
  return false
})
</script>
<template>
  <div>
    <v-card-title class="d-flex align-center pe-2">
      <h1 style="text-align: start">SUMMARY ANNUAL EXPENSE</h1>
    </v-card-title>
    <v-row
      ><v-col cols="12" sm="6"
        ><v-text-field
          class="ma-2"
          v-model="search"
          max-width="200px"
          prepend-inner-icon="mdi-magnify"
          density="compact"
          label="Search"
          single-line
          flat
          hide-details
          variant="solo-filled"
        ></v-text-field
      ></v-col>
      <v-col
        ><v-dialog v-model="dialogYearly" max-width="300">
          <template v-slot:activator="{ props }">
            <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
              <v-icon icon=" mdi-calendar" size="25px" class="mr-2" color="#FFFFFF"></v-icon>
              <div style="text-align: center; color: aliceblue">Select Year</div>
            </v-btn>
          </template>
          <v-card>
            <v-card-title class="font ma-4 pt-6" style="text-align: center"
              >Select Year</v-card-title
            >
            <v-col cols="12" sm="12">
              <v-text-field
                v-model="expensesStore.editedExpense.createDate"
                :readonly="loading"
                class="mb-2"
                label="Select month"
                variant="outlined"
                type="month"
              ></v-text-field>
            </v-col>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                color="red"
                variant="flat"
                style="width: 100px"
                class="mb-3"
                @click="dialogYearly = false"
                >Cancel</v-btn
              >
              <v-btn
                color="success"
                variant="flat"
                style="width: 100px"
                class="mb-3"
                @click="showYearExp()"
                >OK</v-btn
              >
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card> </v-dialog
        ><v-menu id="menu-activator">
          <template v-slot:activator="{ props }">
            <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
              <v-icon icon=" mdi-chart-bar" size="25px" class="mr-2" color="#FFFFFF"></v-icon>
              <div style="text-align: center; color: aliceblue">report</div></v-btn
            ></template
          >
          <v-list>
            <v-list-item @click="showSumYear()"
              ><v-list-item-title style="text-align: center">Report</v-list-item-title></v-list-item
            >
            <!-- <v-list-item @click="showGraphYear()">
              <v-list-item-title style="text-align: center">Graph</v-list-item-title>
            </v-list-item> -->
          </v-list>
        </v-menu></v-col
      >
    </v-row>
    <!-- <v-menu id="menu-activator">
      <template v-slot:activator="{ props }">
        <v-btn class="ma-2" color="rgb(139, 82, 38)" v-bind="props"> Select Branch </v-btn>
      </template>
      <v-list>
        <v-list-item
          v-for="(branch, index) in branchStore.branchs"
          :key="index"
          @click="showTableBranch(branch)"
        >
          <v-list-item-title style="text-align: center">{{ branch.address }}</v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu> -->
  </div>
  <v-tabs v-model="tab" align-tabs="center" color="brown">
    <v-tab :to="{ name: 'expense' }">Expense</v-tab>
    <v-tab :to="{ name: 'monthly-expense' }" v-if="isAdmin">Monthly Expenses</v-tab>
    <v-tab :to="{ name: 'annual-expense' }" v-if="isAdmin">Annual Expenses</v-tab>
  </v-tabs>

  <v-spacer></v-spacer>
  <v-data-table
    v-model:page="page"
    :headers="yearExpenses"
    :items="expensesStore.expenseYear"
    :items-per-page="itemsPerPage"
    ><template v-slot:bottom>
      <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount"></v-pagination>
      </div> </template
    ><template v-slot:[`item.actions`]="{ item }">
      <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
    </template>
  </v-data-table>

  <!-- dialog Expense detail -->
  <v-dialog v-model="dialogView" persistent width="400">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >Expense Details
      </v-card-title>
      <v-card-text>
        <div v-if="selectedExpense" style="text-align: start">
          <p>Date : {{ new Date(selectedExpense.createDate).toLocaleDateString('en-GB') }}</p>
          <p>Name : {{ selectedExpense.name }}</p>
          <p>Branch : {{ selectedExpense.branchName?.address }}</p>
          <p>Bill Type : {{ selectedExpense.billType }}</p>
          <p>Note : {{ selectedExpense.note }}</p>
          <p>Total Amount : {{ selectedExpense.totalAmount }}</p>
        </div>
      </v-card-text>
      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="dialogView = false">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogSumYear" persistent width="1000">
    <v-card>
      <v-card-title class="font ma-4 pt-8" style="text-align: center"
        >Summary Monthly Expense
      </v-card-title>
      <v-card-text style="font-size: larger"
        >ToTal : {{ calculateYearlyTotal(expensesStore.expenseYear) }} ฿</v-card-text
      >
      <v-data-table
        v-model:page="page"
        :headers="yearExpensesDialog"
        :items="expensesStore.expenseYear"
        :items-per-page="itemsPerPage"
        ><template v-slot:bottom>
          <div class="text-center pt-2">
            <v-pagination v-model="page" :length="pageCount"></v-pagination>
          </div>
        </template>
      </v-data-table>

      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="dialogSumYear = false">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- dialog ลบ -->
  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >you want to delete this info? 🗑️</v-card-title
      >
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="red"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="closeDelete"
          >Cancel</v-btn
        >
        <v-btn
          color="success"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="deleteItemConfirm"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<style>
div {
  font-family: 'Kanit';
}
</style>
